@0xf8f8864ba0678056;

using CSharp = import "programming_language/csharp.capnp";
$CSharp.namespace("FabAccessAPI.Schema");

using import "/capnp/rpc.capnp".SturdyRef;
using import "/capnp/persistent.capnp".Persistent;

using import "state.capnp".State;

interface Claimable extends (Persistent) {
    restore @0 ( sturdy :SturdyRef ) -> ( claim :Claim );
    # Restore a previously saved SturdyRef pointing to a Claim

    claim @1 () -> ( claim :Claim );
    # returns NULL if the resource is *currently* not claimable.
    # drop the returned claim capability to unclaim it.
}

interface Claim extends (Persistent) {
    update @0 ( state :State ) -> ();
}
